using Interop.NeoTicker;
using System.Collections;
using System.Reflection;
using System;

namespace KreslikLib.Neo.JukeBox
{
    public class NTIndicatorJukeBox<T> where T : Song
    {
        private ArrayList Songs;
        private int SongIndex;
        private int UniqueID;

        public NTIndicatorJukeBox()
        {
            Songs = new ArrayList();
        }

        public double IDLCallSong(NTIndicatorObjects N)
        {
            UniqueID = N.ItSelf().UniqueId;
            SongIndex = GetSongIndexByID(UniqueID);

            if (SongIndex < 0)
            {
                Type songType = typeof(T);

                T newSong = (T)songType.InvokeMember(songType.Name,
                    BindingFlags.CreateInstance | BindingFlags.Instance | BindingFlags.Public,
                    null, null, null);

                SongIndex = Songs.Add(newSong);

                ((Song)Songs[SongIndex]).UniqueID = UniqueID;
            }

            return ((Song)Songs[SongIndex]).IDLCall(N);
        }

        private int GetSongIndexByID(int ID)
        {
            for (int i = 0; i < Songs.Count; i++)
            {
                if (Songs[i] != null && ((Song)Songs[i]).UniqueID == ID)
                {
                    return i;
                }
            }

            return -1;
        }
    }

    public abstract class Song
    {
        private int uniqueID;

        public int UniqueID
        {
            get { return uniqueID; }
            set { uniqueID = value; }
        }

        public abstract double IDLCall(NTIndicatorObjects N);
    }
}